//+------------------------------------------------------------------+
//|                                                   AMA&AMAsig.mq4 |                                                             
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, by GOODMAN & Mstera  AF "
      
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Sienna
#property indicator_color2 Yellow
#property indicator_color3 Magenta

//---- input parameters
extern int       periodAMA    =26;
extern int       nfast        =5;
extern int       nslow        =20;
extern double    G            =2.0;
extern double    dK           =2.0; 
extern int       AlertMode    =1;
extern double    DeltaPips    =0;
extern double    PointRatio   =10;

//---- buffers
double kAMAbuffer[];
double kAMAupsig[];
double kAMAdownsig[];

//+------------------------------------------------------------------+
double slowSC,fastSC;
datetime pTime;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
   //SetIndexDrawBegin(0,nslow+nfast);
   SetIndexBuffer(0,kAMAbuffer);
   SetIndexBuffer(1,kAMAupsig);
   SetIndexBuffer(2,kAMAdownsig);
 
   IndicatorDigits(4);
   slowSC=(2.0 /(nslow+1));
   fastSC=(2.0 /(nfast+1));
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i,pos=0;
   double noise=0.000000001,signal,ER;
   double dSC,ERSC,SSC,ddK;
   double _Point = Point * PointRatio;
//---- TODO: add your code here
   int cbars=IndicatorCounted();
   if (Bars<=(periodAMA+2)) return(0);
//---- check for possible errors
   if (cbars<0) return(-1);
//---- last counted bar will be recounted
   //if (cbars>0) cbars--;
   //pos=Bars-1;
   //AMA0=Close[pos+1];
   if (cbars==0) int limit = Bars-1;
   if (cbars >0) limit = Bars-cbars;
   
   for(pos=limit;pos>=0;pos--) 
   {
      if(pos>Bars-periodAMA-1) kAMAbuffer[pos]=Close[pos];
      else
      {
      signal=MathAbs(Close[pos]-Close[pos+periodAMA]);
      noise=0.000000001;
      for(i=0;i<periodAMA;i++) noise=noise+MathAbs(Close[pos+i]-Close[pos+i+1]);
      
      if(noise>0) ER =signal/noise;
      dSC=(fastSC-slowSC);
      ERSC=ER*dSC;
      SSC=ERSC+slowSC;
      kAMAbuffer[pos]=kAMAbuffer[pos+1] + MathPow(SSC,G)*(Close[pos]- kAMAbuffer[pos+1]);

      ddK=kAMAbuffer[pos] - kAMAbuffer[pos+1];
      if ((MathAbs(ddK)) > (dK*_Point) && (ddK > 0)) kAMAupsig[pos] =kAMAbuffer[pos]; else kAMAupsig[pos]=0;
      if ((MathAbs(ddK)) > (dK*_Point) && (ddK < 0)) kAMAdownsig[pos]=kAMAbuffer[pos]; else kAMAdownsig[pos]=0; 
      }
   }
//----
  
//----   
   string Message;
   
   
   if(AlertMode > 0)
   { 
      if (kAMAupsig[1] > 0)
      {
	   Message = " "+Symbol()+" M"+Period()+": VarMA Signal for BUY";
	   if (isNewBar()) Alert (Message); 
	   }  
	   else 	  
	   if (kAMAdownsig[1] > 0)
	   {
	   Message = " "+Symbol()+" M"+Period()+": VarMA Signal for SELL";
	   if (isNewBar()) Alert (Message); 
	   } 	         
      else
      if (Close[1] > kAMAbuffer[1] && Close[2] < kAMAbuffer[2])
      {
	   Message = " "+Symbol()+" M"+Period()+": Price Crosses to above VarMA from below";
	   if (isNewBar()) Alert (Message); 
	   }  
      else
      if (Close[1] < kAMAbuffer[1] && Close[2] > kAMAbuffer[2])
      {
	   Message = " "+Symbol()+" M"+Period()+": Price Crosses to below VarMA from above";
	   if (isNewBar()) Alert (Message); 
	   } 
      else
      if (MathAbs(Close[0] - kAMAbuffer[0]) <= DeltaPips*_Point) PlaySound("alert.wav");
   }      
   
   return(0);
  }
//----
bool isNewBar()
{
   bool res=false;
   if (Time[0]!=pTime)
   {
   res=true;
   pTime=Time[0];
   }   
   return(res);
}